# KineMaster iOS

## Build

### Resolve Module Dependencies
In order to build successfully, especially KMDevModules.xcodeproj, the following command must be executed before building the App with Xcode, or CI build with command line.

```
$ make resolve-packages
```
This resolves 3rd party dependencies such as SnapKit required by, for example, KMAssetStoreKit.

## Modules

### Adding or deleting a module source file

If you added a new swift file to `frameworks/KMApp/Sources/KMApp/`, for example, `frameworks/KMDevModules.xcodeproj` must be regenerated to build `KMApp.framework`, `KMDevModules.framework`, and `KineMaster App` successfully.

Here is the steps:

```
$ make update-devmodules
```

Here is what happens with the command execution:

1. Re-generates `KMDevModules.xcodeproj`

>> NOTE: At this point, the default output of re-generated .xcodeproj is set to build KMDevModules.framework as a static library and this will fail to include all the symbols from our modules, including KMApp in this example, which leads to fail to build KineMaster App successfully.

2. Fixes `KMDevModules.xcodeproj` to build `KMDevModules.framework` as a Dynamic Framework
  
  ![KMDevModules as Dynamic Library](/documentation/images/kmdevmodules-dynamiclib.png?raw=true)
  
  >> Mach-O type value of KMDevModules will be reset to `Static Library` whenever re-generate KMDevModules.xcodeproj as a current limitation of our build system. We hope this will be addressed as soon as Swift Package Manager supports importing Objective-C module from Swift module.


